
#include "stdio.h"
#include "assert.h"
#include "stdlib.h"

#include <libunwind.h>
#include <ucontext.h>

void unwinder_( )
{
    unw_context_t         context;
    unw_cursor_t          cursor;

    unw_getcontext(&context);
    unw_init_local(&cursor, &context);

    do {
       unw_word_t ip;
       unw_proc_info_t procInfo;

       assert( unw_get_reg(&cursor, UNW_REG_IP,  &ip) == 0 );
       assert( unw_get_proc_info(&cursor, &procInfo)  == 0 );

       printf(" ip= 0x%016lx  fp= 0x%016lx \n", ip, procInfo.start_ip);
    }
    while (unw_step(&cursor) > 0);
    
    exit(0);
}
